#pragma once

#include "foundation/graphics/types.h"

namespace Foundation
{
	class Mouse
	{
	public:
		enum Button : int
		{
			Left,
			Middle,
			Right,

			_Count
		};

		Mouse();

		void BeginCollect();
		void EndCollect();

		void PushMouseWheelChange(int inDeltaX, int inDeltaY);

		void Update(int inDeltaTick);

		bool IsButtonDown(Button inButton) const;
		bool IsButtonPressed(Button inButton) const;
		bool IsButtonDoublePressed(Button inButton) const;

		Point GetPosition() const;
		Point GetWheelDelta() const;

	private:
		Point m_Position;

		bool m_IsCollecting;

		int m_WheelDeltaX;
		int m_WheelDeltaY;

		int m_ButtonState;
		int m_ButtonStateLast;
		int m_ButtonStateDoublePress;

		int m_TickCounter;
		int m_LastButtonPressedTime[Button::_Count];
	};
}