#pragma once

#include <memory>
#include <string>

namespace Foundation
{
	// Forward declaration
	class IMutex;

	class IPlatform
	{
	protected:
		IPlatform() { }

	public: 
		virtual ~IPlatform() { }

		virtual std::shared_ptr<IMutex> CreateMutex() = 0;
        
		virtual bool Storage_SetCurrentPath(const std::string& inPath) const = 0;

		virtual unsigned int Storage_GetLogicalDrivesCount() const = 0;
		virtual std::string Storage_GetLogicalDriveName(unsigned int inLogicalDrive) const = 0;
        virtual bool Storage_IsSystemFile(const std::string& inPath) const = 0;
        virtual std::string Storage_GetStartupPath() const = 0;
	};
}
