#pragma once

#include "foundation/platform/sdl/platform_sdl.h"
#include <vector>
#include <string>

#ifdef _SF2_LINUX
#include <limits.h>

namespace Foundation
{
	class PlatformSDLLinux final : public PlatformSDL
	{
	public:
		explicit PlatformSDLLinux(int argc, char* argv[]);
		virtual ~PlatformSDLLinux();

        bool Storage_SetCurrentPath(const std::string& inPath) const override;
		unsigned int Storage_GetLogicalDrivesCount() const override;
		std::string Storage_GetLogicalDriveName(unsigned int inLogicalDrive) const override;
        bool Storage_IsSystemFile(const std::string& inPath) const override;
        std::string Storage_GetStartupPath() const override;

	private:
		unsigned long m_LogicalDrivesMask;
		std::vector<std::string> m_LogicalDrivesList;
        
        char m_ApplicationPath[PATH_MAX];
        std::string m_RealHome;
	};
}
#endif
