#pragma once

#include "foundation/platform/sdl/platform_sdl.h"
#include <vector>
#include <string>

#ifdef _SF2_WINDOWS
namespace Foundation
{
	class PlatformSDLWindows final : public PlatformSDL
	{
	public:
		explicit PlatformSDLWindows(int argc, char* argv[]);
		virtual ~PlatformSDLWindows();

        bool Storage_SetCurrentPath(const std::string& inPath) const override;
		unsigned int Storage_GetLogicalDrivesCount() const override;
		std::string Storage_GetLogicalDriveName(unsigned int inLogicalDrive) const override;
        bool Storage_IsSystemFile(const std::string& inPath) const override;
        std::string Storage_GetStartupPath() const override;

	private:
		unsigned long m_LogicalDrivesMask;

		std::vector<std::string> m_LogicalDrivesList;
	};
}
#endif
