#include "utils/keyhookstore.h"

namespace Utility
{
	KeyHookStore::KeyHookStore() = default;

	void KeyHookStore::PassBaseDefinitions(const std::vector<KeyHookStore::HookDefinition>& inDefinitionList)
	{
		assert(m_HookDefinitions.empty());
		for (const auto& definition : inDefinitionList)
			m_HookDefinitions.insert({ definition.m_HookName, definition.m_HookKey });
	}

	void KeyHookStore::OverrideDefinition(const KeyHookStore::HookDefinition& inDefinition)
	{
		auto it = m_HookDefinitions.find(inDefinition.m_HookName);
		assert(it != m_HookDefinitions.end());

		it->second = inDefinition.m_HookKey;
	}


	const KeyHookStore::Key& KeyHookStore::GetKey(const std::string inHookName) const
	{
		auto it = m_HookDefinitions.find(inHookName);
		assert(it != m_HookDefinitions.end());

		return it->second;
	}
}
