#pragma once

#include <assert.h>
#include <functional>
#include <vector>
#include <string>
#include <map>
#include "SDL_keycode.h"

namespace Utility
{
	class KeyHookStore
	{
	public:
		struct Key
		{
			SDL_Keycode m_KeyCode;
			unsigned int m_Modifiers;
		};

		struct HookDefinition
		{
			std::string m_HookName;
			Key m_HookKey;
		};

		KeyHookStore();

		void PassBaseDefinitions(const std::vector<HookDefinition>& inDefinitionList);
		void OverrideDefinition(const HookDefinition& inDefinition);

		const Key& GetKey(const std::string inHookName) const;

	private:
		std::map<std::string, Key> m_HookDefinitions;
	};
}